module pcie_rp_ed_top (
    // FPGA peripherals ports
  	output wire [3:0]  fpga_led_pio,                     
   // HPS memory controller ports
	output wire [14:0] hps_memory_mem_a,                           
	output wire [2:0]  hps_memory_mem_ba,                          
	output wire        hps_memory_mem_ck,                          
	output wire        hps_memory_mem_ck_n,                        
	output wire        hps_memory_mem_cke,                         
	output wire        hps_memory_mem_cs_n,                        
	output wire        hps_memory_mem_ras_n,                       
	output wire        hps_memory_mem_cas_n,                       
	output wire        hps_memory_mem_we_n,                        
	output wire        hps_memory_mem_reset_n,                     
	inout  wire [39:0] hps_memory_mem_dq,                          
	inout  wire [4:0]  hps_memory_mem_dqs,                         
	inout  wire [4:0]  hps_memory_mem_dqs_n,                       
	output wire        hps_memory_mem_odt,                         
	output wire [4:0]  hps_memory_mem_dm,                          
	input  wire        hps_memory_oct_rzqin,                       
    // HPS peripherals  
	output	wire	hps_emac1_inst_TX_CLK, 
	output	wire	hps_emac1_inst_TXD0, 
	output	wire	hps_emac1_inst_TXD1, 
	output	wire	hps_emac1_inst_TX_CTL, 
	input	   wire	hps_emac1_inst_RXD0, 
	input	   wire	hps_emac1_inst_RXD1, 
	output	wire	hps_emac1_inst_TXD2, 
	output	wire	hps_emac1_inst_TXD3, 
	inout	   wire	hps_emac1_inst_MDIO, 
	output	wire	hps_emac1_inst_MDC, 
	input	   wire	hps_emac1_inst_RX_CTL, 
	input	   wire	hps_emac1_inst_RX_CLK, 
	input	   wire	hps_emac1_inst_RXD2, 
	input	   wire	hps_emac1_inst_RXD3, 
	inout  	wire	hps_qspi_inst_IO0, 
	inout	   wire	hps_qspi_inst_IO1, 
	inout	   wire	hps_qspi_inst_IO2, 
	inout	   wire	hps_qspi_inst_IO3, 
	output	wire	hps_qspi_inst_SS0, 
	output	wire	hps_qspi_inst_CLK, 
	inout	   wire	hps_sdio_inst_CMD, 
	inout	   wire	hps_sdio_inst_D0, 
	inout	   wire	hps_sdio_inst_D1, 
	output	wire	hps_sdio_inst_CLK, 
	inout	   wire	hps_sdio_inst_D2, 
	inout	   wire	hps_sdio_inst_D3, 
	inout	   wire	hps_usb1_inst_D0, 
	inout	   wire	hps_usb1_inst_D1, 
	inout	   wire	hps_usb1_inst_D2, 
	inout	   wire	hps_usb1_inst_D3, 
	inout	   wire	hps_usb1_inst_D4, 
	inout	   wire	hps_usb1_inst_D5, 
	inout	   wire	hps_usb1_inst_D6, 
	inout		wire	hps_usb1_inst_D7, 
	input		wire	hps_usb1_inst_CLK, 
	output	wire	hps_usb1_inst_STP, 
	input		wire	hps_usb1_inst_DIR, 
	input		wire	hps_usb1_inst_NXT, 
	input		wire	hps_uart0_inst_RX, 
	output	wire	hps_uart0_inst_TX, 
	input		wire	hps_uart0_inst_CTS, 
	output	wire	hps_uart0_inst_RTS, 
	input		wire	hps_uart1_inst_CTS, 
	output	wire	hps_uart1_inst_RTS, 
	input		wire	hps_uart1_inst_RX, 
	output	wire	hps_uart1_inst_TX, 
	inout		wire	hps_i2c0_inst_SDA, 
	inout		wire	hps_i2c0_inst_SCL, 
	output	wire	hps_trace_inst_CLK, 
	output	wire	hps_trace_inst_D0, 
	output	wire	hps_trace_inst_D1, 
	output	wire	hps_trace_inst_D2, 
	output	wire	hps_trace_inst_D3, 
	output	wire	hps_trace_inst_D4, 
	output	wire	hps_trace_inst_D5, 
	output	wire	hps_trace_inst_D6, 
	output	wire	hps_trace_inst_D7, 
	inout		wire	hps_gpio_inst_GPIO00, // USER_LED_HPS0    R17
	inout		wire	hps_gpio_inst_GPIO17, // USER_LED_HPS2    R15
	inout		wire	hps_gpio_inst_GPIO18,  // USER_LED_HPS3    C16
	inout		wire	hps_gpio_inst_GPIO35,  // USER_PB_HPS0     E15
	inout		wire	hps_gpio_inst_GPIO40,  // USER_LED_HPS1    F16
	inout		wire	hps_gpio_inst_GPIO41,  // USER_PB_HPS1     G16
	inout		wire	hps_gpio_inst_GPIO42,  // USER_PB_HPS2     E16
	inout		wire	hps_gpio_inst_GPIO43,  // USER_PB_HPS3     H16  
    // PCIe signals                  
	 input  wire        hps_pcie_av_hip_avmm_0_hip_serial_rx_in0,                   //          hps_pcie_av_hip_avmm_0_hip_serial.rx_in0
	 input  wire        hps_pcie_av_hip_avmm_0_hip_serial_rx_in1,                   //                                       .rx_in1
	 input  wire        hps_pcie_av_hip_avmm_0_hip_serial_rx_in2,                   //                                       .rx_in2
	 input  wire        hps_pcie_av_hip_avmm_0_hip_serial_rx_in3,                   //                                       .rx_in3
	 output wire        hps_pcie_av_hip_avmm_0_hip_serial_tx_out0,                  //                                       .tx_out0
	 output wire        hps_pcie_av_hip_avmm_0_hip_serial_tx_out1,                  //                                       .tx_out1
	 output wire        hps_pcie_av_hip_avmm_0_hip_serial_tx_out2,                  //                                       .tx_out2
	 output wire        hps_pcie_av_hip_avmm_0_hip_serial_tx_out3,                  //                                       .tx_out3                  
    input  wire        hps_pcie_av_hip_avmm_0_npor_pin_perst,                      //                                       .pin_perst
	 input  wire        hps_pcie_av_hip_avmm_0_refclk_clk,                          //              hps_pcie_av_hip_avmm_0_refclk.clk
	 output wire        pcie_perstn_out,
    // FPGA clock and reset
	input  wire        fpga_clk_50,
   input  wire        fpga_rst_n	
);
 //internal wires
  wire       fpga_led_internal;
  wire       hps_fpga_reset_n;
  wire       pcie_npor_npor;
  wire [4:0] hps_pcie_av_hip_avmm_0_hip_pipe_sim_ltssmstate;
  wire       sync_pcie_por;
  wire       sync_pcie_por_n;
  wire       coreclk_fan_clk;
  wire       coreclk_fan_reset_n;
  wire       pcie_reconfig_clk_locked_fixedclk_locked;
  wire [4:0] hps_reset_req;
  wire       hps_cold_reset;
  wire       hps_warm_reset;
  wire       hps_debug_reset;
  //registers
  reg         L0_led;        // link status ltssm=0xf
  reg         alive_led;     // heart beat 
  reg  [1:0]  linkwidth_led; // link width, 1=x1, 2=x4, skipped x2 and ignored x8
  reg  [25:0] alive_cnt;
  
  
  // connection of internal logics
  assign pcie_perstn_out = ~fpga_led_internal;
  assign fpga_led_pio = {L0_led, alive_led, linkwidth_led[1], ~fpga_led_internal};
  assign pcie_npor_npor = hps_fpga_reset_n & hps_pcie_av_hip_avmm_0_npor_pin_perst & fpga_rst_n;
  //assign sync_pcie_por_n = ~sync_pcie_por; potentailly redundant signal
  
	  
  // logic for LED display derivation
  always @(posedge coreclk_fan_clk or negedge coreclk_fan_reset_n) begin // pcie_refclk_clk to be modified with coreclk_out from PCIe IP later
    if (!coreclk_fan_reset_n) begin
      L0_led        <= 1'b0;      
      alive_led     <= 1'b0;   
      linkwidth_led <= 2'h0;
      alive_cnt     <= 26'd0;
      end
    else begin
      L0_led        <= ~(hps_pcie_av_hip_avmm_0_hip_pipe_sim_ltssmstate[3:0] == 4'hf);
      alive_led     <= alive_cnt[25];   
      linkwidth_led <= {alive_cnt[24],alive_cnt[21]}; // tentatively assign linkwidth_led as flashing display as PCIe HIP has yet exposed the tl_cfg_sts signal
      alive_cnt     <= alive_cnt + 1;   
      end
    end

pcie_rp_ed_5astfd5 soc_inst (
 .clk_clk             (fpga_clk_50), 
 .reset_reset_n       (hps_fpga_reset_n),
 .h2f_reset_reset_n                  (hps_fpga_reset_n), 
 .f2h_warm_reset_req_reset_n         (~hps_warm_reset), 
 .f2h_debug_reset_req_reset_n        (~hps_debug_reset), 
 .f2h_cold_reset_req_reset_n         (~hps_cold_reset), 
 .memory_mem_a        (hps_memory_mem_a), 
 .memory_mem_ba       (hps_memory_mem_ba), 
 .memory_mem_ck       (hps_memory_mem_ck), 
 .memory_mem_ck_n     (hps_memory_mem_ck_n), 
 .memory_mem_cke      (hps_memory_mem_cke), 
 .memory_mem_cs_n     (hps_memory_mem_cs_n), 
 .memory_mem_ras_n    (hps_memory_mem_ras_n), 
 .memory_mem_cas_n    (hps_memory_mem_cas_n), 
 .memory_mem_we_n     (hps_memory_mem_we_n), 
 .memory_mem_reset_n  (hps_memory_mem_reset_n), 
 .memory_mem_dq       (hps_memory_mem_dq), 
 .memory_mem_dqs      (hps_memory_mem_dqs), 
 .memory_mem_dqs_n    (hps_memory_mem_dqs_n), 
 .memory_mem_odt      (hps_memory_mem_odt), 
 .memory_mem_dm       (hps_memory_mem_dm), 
 .memory_oct_rzqin    (hps_memory_oct_rzqin),
 //General Purpose IO
 .pio_rp_reset_external_connection_in_port		(fpga_led_internal), 
 .pio_rp_reset_external_connection_out_port		(fpga_led_internal), 
 //PCIE related IO
 .coreclk_fanout_clk_reset_reset_n              (coreclk_fan_reset_n), 
 .coreclk_fanout_clk_clk                        (coreclk_fan_clk), 
 .pcie_av_hip_avmm_0_hip_serial_rx_in0				(hps_pcie_av_hip_avmm_0_hip_serial_rx_in0), 
 .pcie_av_hip_avmm_0_hip_serial_rx_in1				(hps_pcie_av_hip_avmm_0_hip_serial_rx_in1), 
 .pcie_av_hip_avmm_0_hip_serial_rx_in2				(hps_pcie_av_hip_avmm_0_hip_serial_rx_in2), 
 .pcie_av_hip_avmm_0_hip_serial_rx_in3				(hps_pcie_av_hip_avmm_0_hip_serial_rx_in3), 
 .pcie_av_hip_avmm_0_hip_serial_tx_out0			(hps_pcie_av_hip_avmm_0_hip_serial_tx_out0), 
 .pcie_av_hip_avmm_0_hip_serial_tx_out1			(hps_pcie_av_hip_avmm_0_hip_serial_tx_out1), 
 .pcie_av_hip_avmm_0_hip_serial_tx_out2			(hps_pcie_av_hip_avmm_0_hip_serial_tx_out2), 
 .pcie_av_hip_avmm_0_hip_serial_tx_out3         (hps_pcie_av_hip_avmm_0_hip_serial_tx_out3),
 .pcie_av_hip_avmm_0_npor_pin_perst             (hps_pcie_av_hip_avmm_0_npor_pin_perst), 
 .pcie_av_hip_avmm_0_refclk_clk                 (hps_pcie_av_hip_avmm_0_refclk_clk),
 .pcie_av_hip_avmm_0_hip_pipe_sim_ltssmstate		(hps_pcie_av_hip_avmm_0_hip_pipe_sim_ltssmstate),
 // Tied PCIE input signals
 .pcie_av_hip_avmm_0_hip_pipe_phystatus0    	(1'b0),                 //                                       .phystatus0
 .pcie_av_hip_avmm_0_hip_pipe_phystatus1    	(1'b0),                 //                                       .phystatus1
 .pcie_av_hip_avmm_0_hip_pipe_phystatus2    	(1'b0),                 //                                       .phystatus2
 .pcie_av_hip_avmm_0_hip_pipe_phystatus3    	(1'b0),                 //                                       .phystatus3
 .pcie_av_hip_avmm_0_hip_pipe_rxdata0    		(8'b0),                    //                                       .rxdata0
 .pcie_av_hip_avmm_0_hip_pipe_rxdata1    		(8'b0),                    //                                       .rxdata1
 .pcie_av_hip_avmm_0_hip_pipe_rxdata2    		(8'b0),                    //                                       .rxdata2
 .pcie_av_hip_avmm_0_hip_pipe_rxdata3    		(8'b0),                    //                                       .rxdata3
 .pcie_av_hip_avmm_0_hip_pipe_rxdatak0    		(1'b0),                   //                                       .rxdatak0
 .pcie_av_hip_avmm_0_hip_pipe_rxdatak1    		(1'b0),                   //                                       .rxdatak1
 .pcie_av_hip_avmm_0_hip_pipe_rxdatak2    		(1'b0),                   //                                       .rxdatak2
 .pcie_av_hip_avmm_0_hip_pipe_rxdatak3    		(1'b0),                   //                                       .rxdatak3
 .pcie_av_hip_avmm_0_hip_pipe_rxelecidle0    	(1'b0),                //                                       .rxelecidle0
 .pcie_av_hip_avmm_0_hip_pipe_rxelecidle1    	(1'b0),                //                                       .rxelecidle1
 .pcie_av_hip_avmm_0_hip_pipe_rxelecidle2    	(1'b0),                //                                       .rxelecidle2
 .pcie_av_hip_avmm_0_hip_pipe_rxelecidle3    	(1'b0),                //                                       .rxelecidle3
 .pcie_av_hip_avmm_0_hip_pipe_rxstatus0    		(3'b0),                  //                                       .rxstatus0
 .pcie_av_hip_avmm_0_hip_pipe_rxstatus1    		(3'b0),                  //                                       .rxstatus1
 .pcie_av_hip_avmm_0_hip_pipe_rxstatus2    		(3'b0),                  //                                       .rxstatus2
 .pcie_av_hip_avmm_0_hip_pipe_rxstatus3    		(3'b0),                  //                                       .rxstatus3
 .pcie_av_hip_avmm_0_hip_pipe_rxvalid0    		(1'b0),                   //                                       .rxvalid0
 .pcie_av_hip_avmm_0_hip_pipe_rxvalid1    		(1'b0),                   //                                       .rxvalid1
 .pcie_av_hip_avmm_0_hip_pipe_rxvalid2    		(1'b0),                   //                                       .rxvalid2
 .pcie_av_hip_avmm_0_hip_pipe_rxvalid3    		(1'b0),                   //                                       .rxvalid3
 .pcie_av_hip_avmm_0_hip_ctrl_test_in    		   (32'b0),                    //            hps_pcie_av_hip_avmm_0_hip_ctrl.test_in
 .pcie_av_hip_avmm_0_hip_ctrl_simu_mode_pipe    (1'b0),             //                                       .simu_mode_pipe 
 //.pcie_av_hip_avmm_0_npor_npor    				   (hps_reset_req[3]),                           //                hps_pcie_av_hip_avmm_0_npor.npor
 .pcie_av_hip_avmm_0_npor_npor    				   (pcie_npor_npor),
 //hps related IO 
 .io_hps_io_emac1_inst_TX_CLK                   (hps_emac1_inst_TX_CLK), 
 .io_hps_io_emac1_inst_TXD0                     (hps_emac1_inst_TXD0), 
 .io_hps_io_emac1_inst_TXD1                     (hps_emac1_inst_TXD1), 
 .io_hps_io_emac1_inst_TX_CTL                   (hps_emac1_inst_TX_CTL), 
 .io_hps_io_emac1_inst_RXD0							(hps_emac1_inst_RXD0), 
 .io_hps_io_emac1_inst_RXD1							(hps_emac1_inst_RXD1), 
 .io_hps_io_emac1_inst_TXD2							(hps_emac1_inst_TXD2), 
 .io_hps_io_emac1_inst_TXD3							(hps_emac1_inst_TXD3), 
 .io_hps_io_emac1_inst_MDIO							(hps_emac1_inst_MDIO), 
 .io_hps_io_emac1_inst_MDC								(hps_emac1_inst_MDC), 
 .io_hps_io_emac1_inst_RX_CTL							(hps_emac1_inst_RX_CTL), 
 .io_hps_io_emac1_inst_RX_CLK 						(hps_emac1_inst_RX_CLK), 
 .io_hps_io_emac1_inst_RXD2							(hps_emac1_inst_RXD2), 
 .io_hps_io_emac1_inst_RXD3							(hps_emac1_inst_RXD3), 
 .io_hps_io_qspi_inst_IO0								(hps_qspi_inst_IO0), 
 .io_hps_io_qspi_inst_IO1								(hps_qspi_inst_IO1), 
 .io_hps_io_qspi_inst_IO2								(hps_qspi_inst_IO2), 
 .io_hps_io_qspi_inst_IO3								(hps_qspi_inst_IO3), 
 .io_hps_io_qspi_inst_SS0								(hps_qspi_inst_SS0), 
 .io_hps_io_qspi_inst_CLK								(hps_qspi_inst_CLK), 
 .io_hps_io_sdio_inst_CMD								(hps_sdio_inst_CMD), 
 .io_hps_io_sdio_inst_D0								(hps_sdio_inst_D0), 
 .io_hps_io_sdio_inst_D1								(hps_sdio_inst_D1), 
 .io_hps_io_sdio_inst_CLK								(hps_sdio_inst_CLK), 
 .io_hps_io_sdio_inst_D2								(hps_sdio_inst_D2), 
 .io_hps_io_sdio_inst_D3                        (hps_sdio_inst_D3), 
 .io_hps_io_usb1_inst_D0                        (hps_usb1_inst_D0), 
 .io_hps_io_usb1_inst_D1                        (hps_usb1_inst_D1), 
 .io_hps_io_usb1_inst_D2                        (hps_usb1_inst_D2), 
 .io_hps_io_usb1_inst_D3                        (hps_usb1_inst_D3), 
 .io_hps_io_usb1_inst_D4                        (hps_usb1_inst_D4), 
 .io_hps_io_usb1_inst_D5                        (hps_usb1_inst_D5), 
 .io_hps_io_usb1_inst_D6                        (hps_usb1_inst_D6), 
 .io_hps_io_usb1_inst_D7                        (hps_usb1_inst_D7), 
 .io_hps_io_usb1_inst_CLK                       (hps_usb1_inst_CLK), 
 .io_hps_io_usb1_inst_STP                       (hps_usb1_inst_STP), 
 .io_hps_io_usb1_inst_DIR                       (hps_usb1_inst_DIR), 
 .io_hps_io_usb1_inst_NXT                       (hps_usb1_inst_NXT), 
 .io_hps_io_uart0_inst_RX                       (hps_uart0_inst_RX), 
 .io_hps_io_uart0_inst_TX                       (hps_uart0_inst_TX), 
 .io_hps_io_uart0_inst_CTS                      (hps_uart0_inst_CTS), 
 .io_hps_io_uart0_inst_RTS                      (hps_uart0_inst_RTS), 
 .io_hps_io_uart1_inst_CTS                      (hps_uart1_inst_CTS), 
 .io_hps_io_uart1_inst_RTS                      (hps_uart1_inst_RTS), 
 .io_hps_io_uart1_inst_RX                       (hps_uart1_inst_RX), 
 .io_hps_io_uart1_inst_TX                       (hps_uart1_inst_TX), 
 .io_hps_io_i2c0_inst_SDA                       (hps_i2c0_inst_SDA), 
 .io_hps_io_i2c0_inst_SCL                       (hps_i2c0_inst_SCL), 
 .io_hps_io_trace_inst_CLK                      (hps_trace_inst_CLK), 
 .io_hps_io_trace_inst_D0                       (hps_trace_inst_D0), 
 .io_hps_io_trace_inst_D1                       (hps_trace_inst_D1), 
 .io_hps_io_trace_inst_D2                       (hps_trace_inst_D2), 
 .io_hps_io_trace_inst_D3                       (hps_trace_inst_D3), 
 .io_hps_io_trace_inst_D4                       (hps_trace_inst_D4), 
 .io_hps_io_trace_inst_D5                       (hps_trace_inst_D5), 
 .io_hps_io_trace_inst_D6                       (hps_trace_inst_D6), 
 .io_hps_io_trace_inst_D7                       (hps_trace_inst_D7), 
 .io_hps_io_gpio_inst_GPIO00   	   			   (hps_gpio_inst_GPIO00), // USER_LED_HPS0    R17
 .io_hps_io_gpio_inst_GPIO17   	    				(hps_gpio_inst_GPIO17), // USER_LED_HPS2    R15
 .io_hps_io_gpio_inst_GPIO18   						(hps_gpio_inst_GPIO18),  // USER_LED_HPS3    C16
 .io_hps_io_gpio_inst_GPIO35   						(hps_gpio_inst_GPIO35),  // USER_PB_HPS0     E15
 .io_hps_io_gpio_inst_GPIO40   						(hps_gpio_inst_GPIO40),  // USER_LED_HPS1    F16
 .io_hps_io_gpio_inst_GPIO41   						(hps_gpio_inst_GPIO41),  // USER_PB_HPS1     G16
 .io_hps_io_gpio_inst_GPIO42   						(hps_gpio_inst_GPIO42),  // USER_PB_HPS2     E16
 .io_hps_io_gpio_inst_GPIO43   						(hps_gpio_inst_GPIO43),  // USER_PB_HPS3     H16
 .f2h_stm_hw_events_stm_hwevents     				(28'b0)   // find out what this port does ...
);

//hps_reset hps_reset_inst (
//  .source_clk (fpga_clk_50),
//  .source     (hps_reset_req)
//);

pcie_rp_rst_source reset_inst (
  .source_clk (fpga_clk_50),
  .source     (hps_reset_req)
);

altera_edge_detector pulse_cold_reset (
  .clk       (fpga_clk_50),
  .rst_n     (hps_fpga_reset_n),
  .signal_in (hps_reset_req[0]),
  .pulse_out (hps_cold_reset)
);
  defparam pulse_cold_reset.PULSE_EXT = 6;
  defparam pulse_cold_reset.EDGE_TYPE = 1;
  defparam pulse_cold_reset.IGNORE_RST_WHILE_BUSY = 1;

altera_edge_detector pulse_warm_reset (
  .clk       (fpga_clk_50),
  .rst_n     (hps_fpga_reset_n),
  .signal_in (hps_reset_req[1]),
  .pulse_out (hps_warm_reset)
);
  defparam pulse_warm_reset.PULSE_EXT = 2;
  defparam pulse_warm_reset.EDGE_TYPE = 1;
  defparam pulse_warm_reset.IGNORE_RST_WHILE_BUSY = 1;
  
altera_edge_detector pulse_debug_reset (
  .clk       (fpga_clk_50),
  .rst_n     (hps_fpga_reset_n),
  .signal_in (hps_reset_req[2]),
  .pulse_out (hps_debug_reset)
);
  defparam pulse_debug_reset.PULSE_EXT = 32;
  defparam pulse_debug_reset.EDGE_TYPE = 1;
  defparam pulse_debug_reset.IGNORE_RST_WHILE_BUSY = 1;

endmodule